<?php
/*
Plugin Name: Content Index
Plugin URI: http://codante.org/wordpress-plugin-wp-content-index
Description: 在文章的开头添加内容索引，索引全部根据heading标签生成。
Version: 2.43
Author: 莳子
Author URI: http://codante.org
*/

load_textdomain('content-index', dirname(__FILE__) . "/wp-content-index-" . get_locale() . ".mo");

function content_index_version(){
	return "2.43";
}

function content_index_admininit(){
   if (current_user_can('manage_options'))
 		add_options_page("Content Index", __("Content Index", "content-index"), 8, __FILE__, 'content_index_option');
}

function content_index_option(){
	global $_POST;
	?>
<div class="wrap">
	<h2><?php _e("Content Index", "content-index");?> <font size="1"><?php echo content_index_version();?></font></h2>
	<?php
	if(isset($_POST["action"])):
	
		$_DATA = array();
	
		if ($_POST['action'] == 'save'):
			if(content_index_save()):
				echo '<div class="updated" style="padding:10px;">'.__('Save succeed', 'content-index').'</div>';
			endif;
		endif;
	endif;
	
	$_DATA = array();
	$_DATA = content_index_get_options();
	
?>
<script type="text/javascript">
function check_fixed(self,target){var self=document.getElementById(self);var target=document.getElementById(target);if(self.checked==false){target.checked=false;target.disabled=true;}else{target.disabled=false;}}
</script>
<style type="text/css">
.widefat{line-height:146%}.widefat tbody th{vertical-align:middle}.widefat tbody th, .widefat tbody td{padding:5px 10px}.widefat label{padding-left:6px}
</style>
<form method="post">
<div class="widget">
	<table class="widefat" width="100%" border="0" cellspacing="10" cellpadding="0">
		<tbody>
			<tr class="alternate">
				<th width="200" style="text-align:right" valign="top"><?php _e("Position", "content-index");?></th>
				<td align="left" valign="top">
					<input id="position_0" name="position" type="radio" value="left"<?php if($_DATA["position"] == 'left') echo ' checked="checked"'?> /><label for="position_0"><?php _e("Left", "content-index");?></label>
					<input id="position_1" name="position" type="radio" value="top"<?php if($_DATA["position"] == 'top' || !isset($_DATA["position"])) echo ' checked="checked"'?> /><label for="position_1"><?php _e("Top", "content-index");?></label>
					<input id="position_2" name="position" type="radio" value="right"<?php if($_DATA["position"] == 'right') echo ' checked="checked"'?> /><label for="position_2"><?php _e("Right", "content-index");?></label></td>
			</tr>
			<tr>
				<th width="200" style="text-align:right" valign="top"><?php _e("List number", "content-index");?></th>
				<td align="left" valign="top">
					<input id="listnum" name="listnum" type="checkbox" value="1"<?php if($_DATA["listnum"] === true) echo ' checked="checked"'?> /><label for="listnum"><?php _e("Add a serial number in the index entry.", "content-index");?></label><br />
                	<input id="signheading" name="signheading" type="checkbox" value="1"<?php if($_DATA["signheading"] === true) echo ' checked="checked"'?> /><label for="signheading"><?php _e("Add a serial number in the heading of the article.", "content-index");?></label>
				</td>
			</tr>
			<tr class="alternate">
				<th width="200" style="text-align:right" valign="top"><?php _e("Title", "content-index");?></th>
				<td align="left" valign="top">
					<input onchange="check_fixed('title','title_text')" id="title" name="title" type="checkbox" value="1"<?php if($_DATA["title"] === true) echo ' checked="checked"'?> /><label for="title"><?php _e("Enable title.", "content-index");?></label><br />
					<span style="font-family:Verdana, Geneva, sans-serif">└&nbsp;</span><input<?php if($_DATA["title"] === false) echo ' disabled="disabled"';?> id="title_text" name="title_text" type="text" value="<?php echo $_DATA["title_text"];?>" /><label for="title_text"><?php _e("Custom for title.", "content-index");?></label>
				</td>
			</tr>
			<tr>
				<th width="200" style="text-align:right" valign="top"><?php _e("Show Levels", "content-index");?></th>
				<td align="left" valign="top">
					<input id="level" name="level" type="checkbox" value="1"<?php if($_DATA["level"] === true) echo ' checked="checked"'?> /><label for="level"><?php _e("Enable", "content-index");?></label>
				</td>
			</tr>
			<tr class="alternate">
				<th width="200" style="text-align:right" valign="top"><?php _e("Show Hide button", "content-index");?></th>
				<td align="left" valign="top">
					<input id="hidebt" name="hidebt" type="checkbox" value="1"<?php if($_DATA["hidebt"] === true) echo ' checked="checked"'?> /><label for="hidebt"><?php _e("Enable", "content-index");?></label>
				</td>
			</tr>
			<tr>
				<th width="200" style="text-align:right" valign="top"><?php _e("Show empty", "content-index");?></th>
				<td align="left" valign="top">
					<input id="showempty" name="showempty" type="checkbox" value="1"<?php if($_DATA["showempty"] === true) echo ' checked="checked"'?> /><label for="showempty"><?php _e("Enable", "content-index");?></label>
				</td>
			</tr>
			<tr class="alternate">
				<th width="200" style="text-align:right" valign="top"><?php _e("Show mirage", "content-index");?></th>
				<td align="left" valign="top">
					<input id="showmirage" name="showmirage" type="checkbox" value="1"<?php if($_DATA["showmirage"] === true) echo ' checked="checked"'?> /><label for="showmirage"><?php _e("Enable", "content-index");?></label>
				</td>
			</tr>
			<tr>
				<th width="200" style="text-align:right" valign="top"><?php _e("Excerpt", "content-index");?></th>
				<td align="left" valign="top">
					<input onchange="check_fixed('excerpt_append','excerpt_fixed')" id="excerpt_append" name="excerpt_append" type="checkbox" value="1"<?php if($_DATA["excerpt_append"] === true) echo ' checked="checked"'?> /><label for="excerpt_append"><?php _e("Push excerpt into content.", "content-index");?></label><br />
					<span style="font-family:Verdana, Geneva, sans-serif">└&nbsp;</span><input<?php if($_DATA["excerpt_append"] === false) echo ' disabled="disabled"';?> id="excerpt_fixed" name="excerpt_fixed" type="checkbox" value="1"<?php if($_DATA["excerpt_fixed"] === true) echo ' checked="checked"'?> /><label for="excerpt_fixed"><?php _e("Fixed excerpt in content index.", "content-index");?></label>
				</td>
			</tr>
			<tr class="alternate">
				<th width="200" style="text-align:right" valign="top"></th>
				<td align="left" valign="top">
					<input type="hidden" name="action" value="save" />
					<input class="button-secondary" type="submit" value="  <?php _e("Save", "content-index");?>  " />
				</td>
			</tr>
		</tbody>
	</table>
</div>
</form>
<div class="widget">
	<div style="margin:12px; line-height: 1.5em;">
		<span><?php _e("About the plugin: ", "content-index");?></span><a href="http://codante.org/wordpress-plugin-wp-content-index" target="_blank">http://codante.org/wordpress-plugin-wp-content-index</a>
	</div>
</div>
</div>
<?php
}

function content_index_save(){
	global $_POST;
	$_DATA["position"] = $_POST['position'];
	$_DATA["listnum"] = $_POST['listnum'] == '1' ? true : false;
	$_DATA["level"] = $_POST['level'] == '1' ? true : false;
	$_DATA["title"] = $_POST['title'] == '1' ? true : false;
	$_DATA["title_text"] = trim($_POST['title_text']);
	$_DATA["hidebt"] = $_POST['hidebt'] == '1' ? true : false;
	$_DATA["showempty"] = $_POST['showempty'] == '1' ? true : false;
	$_DATA["showmirage"] = $_POST['showmirage'] == '1' ? true : false;
	$_DATA["excerpt_append"] = $_POST['excerpt_append'] == '1' ? true : false;
	$_DATA["excerpt_fixed"] = $_POST['excerpt_fixed'] == '1' ? true : false;
	$_DATA["signheading"] = $_POST['signheading'] == '1' ? true : false;
	
	update_option("content_index_option", $_DATA);
	
	return true;
}

function content_index_init(){
	global $post;
	if (is_object($post)) $post_id = $post->ID;
	$disable = get_post_meta($post_id, '_content_index_disable', true);
	
	if(	is_singular() && $disable != '1' ){
		echo '<link rel="stylesheet" href="'.get_bloginfo('wpurl').'/wp-content/plugins'.substr(dirname(__FILE__), strrpos(dirname(__FILE__), '/')).'/style.css'.'" type="text/css" media="all" />'."\r\n";
		add_filter('the_content', 'content_index_conversion', 20);
	}
}
/**
 * 避免重复访问数据库
 */
function content_index_get_options(){
	global $content_index_options;
	!isset($content_index_options) && $content_index_options = get_option("content_index_option");
	return $content_index_options;
}

function content_index_conversion($content){	
	$_CONFIGURE = content_index_get_options();
	if($_CONFIGURE["excerpt_append"]):
		if($_CONFIGURE["excerpt_fixed"]):
			$content = excerpt_into_content($content);
			$content = content_index_create($content);
		else:
			$content = content_index_create($content);
			$content = excerpt_into_content($content);
		endif;
	else:
		$content = content_index_create($content);
	endif;
	return $content;
}

function excerpt_into_content($content){
	global $post;
	$excerpt = trim($post->post_excerpt);
	if(!empty($excerpt)):
		$content = '<h2>' . __("Description", "content-index") . '</h2><p>' . $excerpt . '</p>' . $content;
	endif;
	
	return $content;
}

function content_index_analysis(&$content){
	
	$_CONFIGURE = content_index_get_options();
	
	$hlist = content_index_GCBR("/<h(\d)([^>]*)>(.*)<\/h\d>/isU", $content, 1);
	
	if(!empty($hlist)):
	
		$min_level = 99;
		
		$new_hlist = array();
		
		$_tp = array();
		$_tp_level = 0;
		foreach($hlist as $hk => $hv):
		
			$index = $hk + 1;

			$hv[2] = preg_match("/id=/", $hv[2]) ? preg_replace("/.*id=\"?([^\"]*)\"?.*/is", "$1", $hv[2]) : '';		
			$hv[3] = trim(strip_tags($hv[3]));
			
			if(empty($hv[2])):
			
				if(empty($hv[3])){
					$hv[3] = __("Index", "content-index") . "_" . $index;
					$hv["empty"] = 1;
				}
				
				$idIndex = $hv[3];
				
				$replace = preg_replace("/(<h\d)([^>]*>.*<\/h\d>)/is", "$1".' id="'.$idIndex.'"'."$2", $hv[0], 1);
			else :
				$idIndex = $hv[2];
				$replace = $hv[0];
			endif;
			
			
			
			$hv["index"] = $index;
			$hv["resource"] = $hv[0];
			$hv["replace"] = $replace;
			$hv["slug"] = $idIndex;
			$hv["content"] = $hv[3];
			$hv["level"] = intval($hv[1]);
			
			#$hv["nslug"] = 'n_'.md5($idIndex);	#name识别
			#$hv["replace"] = preg_replace("/(<h\d[^>]*>)(.*)(<\/h\d>)/is", "$1".'<a name="'.$hv["nslug"].'"></a><span>'."$2".'</span>'."$3", $hv["replace"], 1);
			
			#确认最小(浅)层级时排除摘要
			if(!($_CONFIGURE["excerpt_fixed"] && $hk == 0)) $min_level = $min_level > $hv["level"] ? $hv["level"] : $min_level;
			
			unset($hv[0], $hv[1], $hv[2], $hv[3]);
			
			$deep = $hv["level"] - $_tp_level;
			
			if($_tp_level > 0 && $deep > 1){
				for(;$deep > 1; $deep--){
					$new_hlist[] = array("level" => $hv["level"] - $deep + 1);
				}
			}
			$new_hlist[] = $hv;
			
			$_tp_level = $hv["level"];
			
		endforeach;
		
		$hlist = $new_hlist;
		$etp_level = $min_level - 1;
		
		#将摘要置于最小(浅)层级
		if($_CONFIGURE["excerpt_fixed"]) $hlist[0]["level"] = $min_level;
		
		#去掉没有出现的上一级(如： h1为第一级, 但h1从未出现过, 最高级只到h2, 那么h2将作为第一级出现)
		if($etp_level > 0)
			foreach($hlist as $hk => $hv)
				$hlist[$hk]["level"] -= $etp_level;
		
		$_tp = array();
		$_tp_sign = array();
		foreach($hlist as $hk => $hv){
			
			$parent = $hv["level"] - 1;			
			
			if($parent > 0){
				
				#处理子集的结构
				while(!isset($_tp[$parent])){
					$mirage = array();
					$mirage["child"][] = $hv;
					$hv = $mirage;
					$parent --;
				}
				
				$hlist[$_tp[$parent]]["child"][$hk] = $hv;                  #把元素继承在父级，原来的位置保留。
				$hlist[$hk] = &$hlist[$_tp[$parent]]["child"][$hk];         #在原来的元素位置上创建指针，保持索引关系不变，方便处理更深的层级。
			}
			
			$_tp_sign = array_slice($_tp_sign, 0, $hv["level"], TRUE);
			empty($_tp_sign[$hv["level"]]) && $_tp_sign[$hv["level"]] = 0;
			$_tp_sign[$hv["level"]]++;
			$hlist[$hk]["sign"] = join(".", $_tp_sign);
			
			$_tp[$hv["level"]] = $hk;
			$_tp = array_slice($_tp, 0, $hv["level"], TRUE);
			
		}

		#清理指针项
		foreach($hlist as $hk => $hv)
			if($hv["level"] > 1)
				unset($hlist[$hk]);
		
		return $hlist;
		
	endif;
	
	return array();
}

function content_index_heading_list_deep($list, &$content, $conf = array(), $deep = 1){
	
	foreach($list as $hk => $hv){
		
		if($conf["signheading"]){
			$pos = strpos($hv["replace"], '>');
			$hv["replace"] = substr($hv["replace"], 0, $pos + 1)."<em>".$hv["sign"].".</em>".substr($hv["replace"], $pos + 1);
			$hv["replace"] = preg_replace("/(<h\d)([^>]*>.*<\/h\d>)/is", "$1".' class="content-index-heading content-index-heading-level-'.$deep.'"'.' name=""'."$2", $hv["replace"], 1);
		}
		
		$content = str_replace($hv["resource"], $hv["replace"], $content);
		
		$v .= '<li class="content-index-level-'.$deep.'">';
		
		$v .= ''
			.'<a'
			.((($hv["index"] || $conf["showmirage"]) && (!isset($hv["empty"]) || $conf["showempty"])) ? '' : ' class="hide"')
			.(empty($hv["index"]) ? ' onclick="return false;"' : '')
			.' href="'.get_permalink()."#".$hv["slug"].'"'
			.' title="'.$hv["content"].'"'
			.'>'
				.( $conf["listnum"] ? '<em>'.$hv["sign"].'</em>' : '' )
				.'<span>'.$hv["content"].'</span>'
			.'</a>';

		if(isset($hv["child"])){
			$v .= '<ul class="children">' . content_index_heading_list_deep( $hv["child"], $content, $conf, $deep + 1) . '</ul>';
		}
		$v .= '</li>';
	}
	return $v;
}

function content_index_heading_list($list, &$content, $conf = array(), $deep = 1){
	
	foreach($list as $hk => $hv){
		
		if($conf["signheading"]){
			$pos = strpos($hv["replace"], '>');
			$hv["replace"] = substr($hv["replace"], 0, $pos + 1)."<em>".$hv["sign"].".</em>".substr($hv["replace"], $pos + 1);
			$hv["replace"] = preg_replace("/(<h\d)([^>]*>.*<\/h\d>)/is", "$1".' class="content-index-heading content-index-heading-level-'.$deep.'"'."$2", $hv["replace"], 1);
		}
		
		$content = str_replace($hv["resource"], $hv["replace"], $content);
		
		$v .= '<li class="content-index-level-'.$deep.'">';
		
		$v .= ''
			.'<a'
			.((($hv["index"] || $conf["showmirage"]) && (!isset($hv["empty"]) || $conf["showempty"])) ? '' : ' class="hide"')
			.(empty($hv["index"]) ? ' onclick="return false;"' : '')
			.' href="'.get_permalink()."#".$hv["slug"].'"'
			.' title="'.$hv["content"].'"'
			.'>'
				.( $conf["listnum"] ? '<em>'.$hv["index"].'</em>' : '' )
				.'<span>'.$hv["content"].'</span>'
			.'</a>';
		$v .= '</li>';
		
		if(isset($hv["child"])){
			$v .= content_index_heading_list( $hv["child"], $content, $conf, $deep + 1);
		}
	}
	return $v;
}

function content_index_create($content){
	$hlist = content_index_analysis($content);
	
	if(!empty($hlist)):
	
		$_CONFIGURE = content_index_get_options();
		
		if($_CONFIGURE["level"]){
			$hunits = content_index_heading_list_deep($hlist, $content, $_CONFIGURE, 1);
		} else {
			$hunits = content_index_heading_list($hlist, $content, $_CONFIGURE, 1);
		}

		if(empty($hunits)):
			$contentIndex = '';
		else:
			
			$style = '';
			if($_CONFIGURE["position"] == 'top'):
				$style = ' style="float:left;"';
			elseif($_CONFIGURE["position"] == 'left'):
				$style = ' style="margin:0 10px 10px 0;float:left;"';
			elseif($_CONFIGURE["position"] == 'right'):
				$style = ' style="margin:0 0 10px 10px;float:right;"';
			endif;

			$contentIndex = '<div id="content-index" class="content-index"'.$style.'>';
			
			if($_CONFIGURE["title"]):
				$contentIndex .= '<div class="content-index-title">'.(empty($_CONFIGURE["title_text"]) ? __("Content Index", "content-index") : $_CONFIGURE["title_text"]).'</div>';
			endif;
			
			if($_CONFIGURE["hidebt"]):
				$contentIndex .= ''
					.'<span class="content-index-toctoggle">[<a id="content-index-togglelink" href="javascript:wci_toggleToc()">'.__("hide", "content-index").'</a>]</span>'
					.'
<script type="text/javascript" language="javascript">
window.wci_showTocToggle=true;function wci_toggleToc(){var toggleTocShow="'.__("show", "content-index").'";var toggleTocHide="'.__("hide", "content-index").'";if(window.wci_showTocToggle){window.wci_showTocToggle=false;document.getElementById("content-index-contents").style.display="none";document.getElementById("content-index-togglelink").innerHTML=toggleTocShow}else{window.wci_showTocToggle=true;document.getElementById("content-index-contents").style.display="block";document.getElementById("content-index-togglelink").innerHTML=toggleTocHide}}
</script>
';
			endif;
			
			$contentIndex .= '<ul id="content-index-contents">'.$hunits.'</ul>';
			$contentIndex .= '</div>';
			
			if($_CONFIGURE["position"] == 'top'):
				$contentIndex .= '<div style="clear:both;overflow:hidden;height:2em"></div>';
			endif;
			
		endif;
		$content = $contentIndex . $content;
	endif;
	
	return $content;
}

/**
 * Get content by regex
 */
function content_index_GCBR($regex, &$content, $rank = 0){
	$ranks = array(PREG_PATTERN_ORDER, PREG_SET_ORDER);
	$regex && preg_match_all($regex, $content, $matche, $ranks[$rank]);
	return $matche;
}

/**
 * Get some feedback for me. 获取一些您的基本信息
 * Help us better serve you. 以便于我们更好的问您服务
 */
function content_index_feedback(){
	if(function_exists( wp_remote_post )){
		wp_remote_post("http://codante.org/stat.php", array('body'=>array("slug"=>"wp-content-index","site"=>get_bloginfo("url"),"version"=>get_bloginfo("version"),"email"=>get_bloginfo("admin_email"), "check"=>"9816O1R5I+HZ5rw9G8qpTvPAIvf+RA8HWSsZEJ7sfziGmwqYjBvD84FzL9M2", "remarks"=>"plugin_version:" . content_index_version())));
	}
}
register_activation_hook( __FILE__, 'content_index_feedback' );   #You can mask this line of code.

function content_index_metabox(){
	//if( function_exists('add_meta_box') ) {
		if( function_exists('get_post_types')){		
			$mrt_pts = get_post_types('','names');
			foreach ($mrt_pts as $pt) {
				if($pt == 'post' || $pt == 'page'){
					add_meta_box('content-index', __("Content Index", "content-index"), 'content_index_meta', $pt);
				}
			}
		}else{
			add_meta_box('content-index', __("Content Index", "content-index"), 'content_index_meta', 'post');
			add_meta_box('content-index', __("Content Index", "content-index"), 'content_index_meta', 'page');
		}

	//} else {
		//add_action('dbx_post_advanced', array($aiosp, 'add_meta_tags_textinput'));
		//add_action('dbx_page_advanced', array($aiosp, 'add_meta_tags_textinput'));
	//}
}

function content_index_meta(){
	global $post;
	$post_id = $post;
	if (is_object($post_id)) $post_id = $post_id->ID;
	$disable = htmlspecialchars(stripcslashes(get_post_meta($post_id, '_content_index_disable', true)));
?>
	<div>
    	<input type="hidden" name="edit-content-index-nonce" value="<?php echo wp_create_nonce('edit-content-index-nonce') ?>" />
    	<input value="content_index_edit" type="hidden" name="content_index_edit" />
        <input<?php echo $disable == '1' ? ' checked="checked"' : '';?> id="content_index_disable" name="content_index_disable" type="checkbox" value="1" />
    	<label for="content_index_disable"><?php _e('Disabled in this article/page', 'content-index');?></label>
    </div>
<?php
}

function content_index_meta_tags($id){
	$content_index_edit = $_POST["content_index_edit"];
	$nonce = $_POST["edit-content-index-nonce"];
	if(isset($content_index_edit) && !empty($content_index_edit) && wp_verify_nonce($nonce, 'edit-content-index-nonce')){
		$disable = $_POST["content_index_disable"];
		delete_post_meta($id, '_content_index_disable');
		$disable == '1' && add_post_meta($id, '_content_index_disable', $disable);
	}
}

add_action('edit_post', 'content_index_meta_tags');
add_action('publish_post', 'content_index_meta_tags');
add_action('save_post', 'content_index_meta_tags');
add_action('edit_page_form', 'content_index_meta_tags');

add_action('admin_menu', 'content_index_metabox');
add_action('admin_menu','content_index_admininit');
add_filter('wp_head','content_index_init');
?>